/*
* cache.h:
*
* Copyright (c) 2001 James McKenzie <james@fishsoup.dhs.org>,
* All rights reserved.
*
*/

/*
 * $Id: cache.h,v 1.6 2001/12/16 17:44:02 root Exp $
 */

/*
 * $Log: cache.h,v $
 * Revision 1.6  2001/12/16 17:44:02  root
 * #
 *
 * Revision 1.5  2001/12/16 17:33:58  root
 * #
 *
 * Revision 1.4  2001/12/06 17:47:08  root
 * #
 *
 * Revision 1.3  2001/12/06 16:18:04  root
 * #
 *
 * Revision 1.2  2001/12/06 04:26:39  root
 * #
 *
 * Revision 1.1  2001/12/06 01:02:21  root
 * #
 *
 */

#ifndef __CACHE_H__
#define __CACHE_H__

class TileDescription
{
public:
  virtual int issame (TileDescription *, TileDescription *) = 0;
};

class TileCache;

class Tile
{
public:
  Tile * prev, *next;
  TileCache *parent;
  TileDescription *td;          //Description
  int lastuse;                  //Used to decide who to drop
  int size;                     //Approximate size in bytes
  GdkPixbuf *b;                 //Image
  ~Tile ();
};

class TileCache
{
public:
  TileCache ();
  int serial;
  int numtiles;
  int numbytes;
  int maxtiles;
  int maxbytes;
  Tile *head, *tail;
  void add (Tile *);
  Tile *find (TileDescription *);
  ~TileCache ();
};


#endif /* __CACHE_H__ */
