/*
 * cmd_p.lex:
 *
 * Copyright (c) 2000 James McKenzie <james@fishsoup.dhs.org>,
 * All rights reserved.
 *
 */
%{
static char rcsid[]="$Id: cmd_p.lex,v 1.1 2002/08/17 11:30:19 root Exp $";

/*
 *
 * $Log: cmd_p.lex,v $
 * Revision 1.1  2002/08/17 11:30:19  root
 * #
 *
 * Revision 1.1  2002/08/15 15:30:59  root
 * #
 *
 * Revision 1.4  2000/10/07 18:30:03  root
 * #
 *
 * Revision 1.3  2000/09/24 01:12:43  root
 * #
 *
 * Revision 1.2  2000/09/19 03:53:27  root
 * #
 *
 * Revision 1.1  2000/09/13 15:13:40  root
 * #
 *
 *
 */


extern int cmd_p_read(char *,int );
#define YY_INPUT(buf,result,size) result=cmd_p_read((char *) buf,size);

#include "../project.h"
#include "cmd_p.tab.h"

// line number
int cmd_p_line = 1;


%}

%x		COMMENT

endofline	\n
quotes		[\"']
space		[ \t,]+
number1		[0123456789]+\.[01234567890]*
number2		\.[01234567890]+
inumber		[0123456789]+

%%

gis_cmd			;
{space}			;
{endofline}		{ cmd_p_line++; }

\/\/.*			;
"/*"			BEGIN COMMENT;
<COMMENT>.	|
<COMMENT>\n		;
<COMMENT>"*/"		BEGIN INITIAL;


add_map			{ return ADD_MAP; }
remove_map		{ return REMOVE_MAP; }
add			{ return ADD_MAP; }
remove			{ return REMOVE_MAP; }
set_position		{ return SET_POSITION; }
position		{ return SET_POSITION; }
set_cs			{ return SET_CS; }
cs			{ return SET_CS; }
set_coordinate_system	{ return SET_CS; }
coordinate_system	{ return SET_CS; }
set_scale		{ return SET_SCALE; }
scale			{ return SET_SCALE; }
set_size		{ return SET_SIZE; }
size			{ return SET_SIZE; }
set_filename		{ return SET_FILENAME; }
filename		{ return SET_FILENAME; }

[{]			{ return BRACE_IN; }

[}]			{ return BRACE_OUT; }

{quotes}[^\"]*{quotes} { 
	strcpy(cmd_p_lval.string , cmd_p_text + 1); 
	cmd_p_lval.string[strlen(cmd_p_lval.string) - 1] = 0; 
	return STRING;
}

{number1} {
	cmd_p_lval.number=atof(cmd_p_text);
	return NUMBER;
}

{number2} {
	cmd_p_lval.number=atof(cmd_p_text);
	return NUMBER;
}

{inumber} {
	cmd_p_lval.inumber=atoi(cmd_p_text);
	return INUMBER;
}


.			{ return cmd_p_text[0]; }

%%


int cmd_p_wrap()
{
	return 1;
}

