/*
 * cmd_p.y:
 *
 * Copyright (c) 2002 James McKenzie <james@fishsoup.dhs.org>,
 * All rights reserved.
 *
 */

%{
static char rcsid[] = "$Id: cmd_p.y,v 1.1 2002/08/17 11:30:19 root Exp $";

/*
 * $Log: cmd_p.y,v $
 * Revision 1.1  2002/08/17 11:30:19  root
 * #
 *
 * Revision 1.1  2002/08/15 15:30:59  root
 * #
 *
 * Revision 1.8  2001/10/12 13:51:11  root
 * #
 *
 * Revision 1.7  2001/10/04 18:21:16  root
 * #
 *
 * Revision 1.6  2001/10/04 18:00:36  root
 * #
 *
 * Revision 1.5  2000/10/07 18:30:03  root
 * #
 *
 * Revision 1.4  2000/09/24 01:12:43  root
 * #
 *
 * Revision 1.3  2000/09/19 05:06:22  root
 * #
 *
 * Revision 1.2  2000/09/19 03:53:27  root
 * #
 *
 * Revision 1.1  2000/09/13 15:13:40  root
 * #
 *
 */


#include "../project.h"
extern "C" {
#include <ctype.h>
};


// state machine stuff

typedef enum {START, BRACE_IN,BRACE_OUT,ADD_MAP,REMOVE_MAP,SET_POSITION,SET_CS,SET_SCALE,SET_SIZE,SET_FILENAME} THING ;
typedef enum {INIT, IN_BRACE } STATE ;

extern int cmd_p_read(char *buf,int len);



%}

%token BRACE_IN BRACE_OUT STRING ADD_MAP REMOVE_MAP SET_POSITION SET_CS SET_SCALE SET_SIZE SET_FILENAME NUMBER INUMBER

%union {
		char string[1024];
		double number;
		int inumber;
	}

%start map_list

%%


map_list:	map
	|	map_list map
	;

map:		BRACE_IN decl_list BRACE_OUT		{ cmd_p_endbrace() ;};
	;

decl_list:	decl 
	|	decl_list decl 
	;

decl:		ADD_MAP STRING ';'			{ cmd_p_addmap($2.string); }
	|	REMOVE_MAP STRING ';'			{ cmd_p_removemap($2.string); }
	|	SET_POSITION STRING STRING ';'		{ cmd_p_setpos($2.string,$3.string); }
	|	SET_CS	STRING ';'			{ cmd_p_setcs($2.string); }
	|	SET_SCALE NUMBER ';'			{ cmd_p_setscale($2.number); }
	|	SET_SCALE INUMBER ';'			{ cmd_p_setscale((double) $2.inumber);}
	|	SET_SIZE INUMBER INUMBER ';'		{ cmd_p_setsize($2.inumber,$3.inumber);}
	|	SET_FILENAME STRING ';'			{ cmd_p_setfn($2.string); }
	|	';'
        ;

%%

extern int cmd_p_line;
extern char *cmd_p_text;
extern char *cmd_p_name;

static int state=INIT;

extern int cmd_p_lex(void);


void cmd_p_error(char *s)
{
	fprintf(stderr, "cmd_p: %s line %d: %s near `%s'\n", cmd_p_name,cmd_p_line, s, cmd_p_text);
}

#define THROW_ERROR(a)	do { fprintf(stderr, "cmd_p: %s line %d: %s near `%s'\n", cmd_p_name,line, (a), c1); } while(0)


static void do_stuff(THING thing, char *c1, char *c2)
{
#if 0
Eweid e;
char *f;

switch(thing) {
case START:
	state=INIT;
	break;
case WORK:
case NOWORK:
        f=de_relativise(c1,cmd_pname);
	e=filename_to_eweid(f);
	free(f);

        if (EWEID_IS_NONE(e)) {
		fprintf(stderr,"%s: %s doesn't exist\n",cmd_pname,c1);
		return;
	} else {
		switch(thing) {
		case WORK:
			mtd_add_work(e);
			break;
		case NOWORK:
			mtd_remove_work(e);
			break;
		default:
		;
		}
	}
	Obj_Delete(e);
	
break;
case TEXT:
	f=de_relativise(c1,cmd_pname);
	e=filename_to_eweid(f);
	free(f);

        if (EWEID_IS_NONE(e)) {
		fprintf(stderr,"%s: %s doesn't exist\n",cmd_pname,c1);
		return;
	} else {
	mtd_add_text(e,c2);
        mtd_add_work(e);
	}
	Obj_Delete(e);
	
	break;
case URI:
	f=de_relativise(c1,cmd_pname);
	e=filename_to_eweid(f);
	free(f);

//        mtd_remove_text(e);
        mtd_add_text(e," ");

        if (EWEID_IS_NONE(e)) {
		fprintf(stderr,"%s: %s doesn't exist\n",cmd_pname,c1);
		return;
	} else {
/*FIXME: are these files or uris?*/
	f=de_relativise(c2,cmd_pname);
	mtd_add_uri(e,f);
        free(f);
	}
	Obj_Delete(e);
	break;
case GROUP:
	if (state==FILE_LIST) THROW_ERROR("Error 1");
	state=INIT;
	f=de_relativise(c1,cmd_pname);
	mtd_make_group(f,el);
	free(f);
	Obj_Delete(el);
	el=NULL;
	break;
case AFILE:
	f=de_relativise(c1,cmd_pname);
	e=filename_to_eweid(f);
	free(f);

	if (!el) el=CREATE_LIST(Eweid);


        if (EWEID_IS_NONE(e)) {
		fprintf(stderr,"%s: %s doesn't exist\n",cmd_pname,c1);
	return;
	}

//        mtd_remove_text(e);
        mtd_add_text(e," ");
        mtd_remove_work(e);


	Obj_Insert(el,e,ObjInsertTail);

	break;

default:
	break;
}
#endif
}



