/*
* cmdview.h:
*
* Copyright (c) 2001 James McKenzie <james@fishsoup.dhs.org>,
* All rights reserved.
*
*/

/*
 * $Id: cmdview.h,v 1.5 2002/08/17 15:27:53 root Exp $
 */

/*
 * $Log: cmdview.h,v $
 * Revision 1.5  2002/08/17 15:27:53  root
 * #
 *
 * Revision 1.4  2002/08/17 11:30:19  root
 * #
 *
 * Revision 1.3  2002/08/15 15:30:59  root
 * #
 *
 * Revision 1.2  2002/08/15 11:41:18  root
 * #
 *
 * Revision 1.1  2002/08/15 11:41:06  root
 * #
 *
 * Revision 1.8  2002/08/12 15:42:48  root
 * #
 *
 * Revision 1.7  2002/06/21 17:33:06  root
 * #
 *
 * Revision 1.6  2001/12/16 17:44:02  root
 * #
 *
 * Revision 1.5  2001/12/16 17:33:58  root
 * #
 *
 * Revision 1.4  2001/12/06 21:04:21  root
 * #
 *
 * Revision 1.3  2001/12/06 17:47:08  root
 * #
 *
 * Revision 1.2  2001/12/06 16:18:04  root
 * #
 *
 * Revision 1.1  2001/12/06 04:26:39  root
 * #
 *
 */

#ifndef __CMDVIEW_H__
#define __CMDVIEW_H__


class CmdView
{
public:

  LatLon pos;
  double scale;
  int w, h;

  Map **maps;			//list of maps; [not owned by us]
  int *usemaps;                 //list of maps to use [?owned by us]
  int nmaps;
  ImageCoordSystem *imgcoordsys; //ImageCoordinateSystem [not owned by us]


  ViewCoordSystem make_vcs(void);


  void move(LatLon);
  void setscale(double);
  void setsize(int, int);
  int setcs(char*);
  int hidemaps(char*);
  int showmaps(char*);


  CmdView (ImageCoordSystem *ics, Map **mps, int *which, int n, LatLon where, double iscale, int iw, int ih);
  CmdView (Map **mps, int n);
  ~CmdView ();


  int render(FILE *f);
  int render(char *name);
  GdkPixbuf *CmdView::do_render(int slice_x, int slice_y, int slice_w, int slice_h, int slice, int nslices);
}
;


#endif /* __CMDVIEW_H__ */
