/*
* drawable.h:
*
* Copyright (c) 2001 James McKenzie <james@fishsoup.dhs.org>,
* All rights reserved.
*
*/

/*
 * $Id: drawable.h,v 1.14 2002/08/17 15:50:56 root Exp root $
 */

/*
 * $Log: drawable.h,v $
 * Revision 1.14  2002/08/17 15:50:56  root
 * #
 *
 * Revision 1.13  2002/08/17 15:27:53  root
 * #
 *
 * Revision 1.12  2002/08/15 15:30:59  root
 * #
 *
 * Revision 1.11  2002/08/15 11:41:18  root
 * #
 *
 * Revision 1.10  2002/08/15 11:41:06  root
 * #
 *
 * Revision 1.9  2002/08/12 15:42:48  root
 * #
 *
 * Revision 1.8  2001/12/16 17:56:08  root
 * #
 *
 * Revision 1.7  2001/12/16 17:44:02  root
 * #
 *
 * Revision 1.6  2001/12/16 17:33:58  root
 * #
 *
 * Revision 1.5  2001/12/06 17:47:08  root
 * #
 *
 * Revision 1.4  2001/12/06 16:18:04  root
 * #
 *
 * Revision 1.3  2001/12/06 04:26:39  root
 * #
 *
 * Revision 1.2  2001/12/06 01:02:21  root
 * #
 *
 * Revision 1.1  2001/12/05 20:13:37  root
 * #
 *
 */

#ifndef __DRAWABLE_H__
#define __DRAWABLE_H__

class GisRect
{
  int x, y;
  int w, h;
};

class GisDrawable
{
public:
  virtual void render (GdkPixbuf * b, int sx, int sy, int dx, int dy, int rw,
                       int rh, int dithx, int dithy) = 0;
  virtual void zap (int dx, int dy, int zw, int zh) = 0;
  virtual void line (int x1, int y1, int x2, int y2, GisColor c, int lw) = 0;
  virtual void text (char *, int x, int y, GisColor c, int fs) = 0;
  virtual void textsize (char *, int fs, int *tw, int *th) = 0;
  virtual void composite(GdkPixbuf *b, int sx, int sy, int w, int h, int dx, int dy) = 0;
  int inarea(int x, int y);
  int w, h;
  int rw, rh;
  int sx, sy;
  ~GisDrawable () {} ;
};

class GisDrawableX: public GisDrawable
{
private:
  void SetColor(GisColor *c);
public:
  void render (GdkPixbuf * b, int sx, int sy, int dx, int dy, int rw, int rh,
               int dithx, int dithy);
  void zap (int dx, int dy, int zw, int zh);
  void line (int x1, int y1, int x2, int y2, GisColor c, int lw);
  void text (char *, int x, int y, GisColor c, int fs);
  void textsize (char *, int fs, int *tw, int *th);
  void composite(GdkPixbuf *b, int sx, int sy, int w, int h, int dx, int dy);
  GisDrawableX (Display * d, Window w, GC gc, int uw, int uh);
  Display *dpy;
  Drawable drw;
  GC gc;
};


class GisDrawableGdkPB: public GisDrawable
{
public:
  void render (GdkPixbuf * b, int sx, int sy, int dx, int dy, int rw, int rh,
               int dithx, int dithy);
  void zap (int dx, int dy, int zw, int zh);
  void line (int x1, int y1, int x2, int y2, GisColor c, int lw);
  void text (char *, int x, int y, GisColor c, int fs);
  void textsize (char *, int fs, int *tw, int *th);
  void composite(GdkPixbuf *b, int sx, int sy, int w, int h, int dx, int dy);
  GisDrawableGdkPB (GdkPixbuf * ib);
  GisDrawableGdkPB (GdkPixbuf * ib, int iw, int ih);
  GisDrawableGdkPB (GdkPixbuf * ib, int iw, int ih, int, int, int, int);
  GdkPixbuf *b;
  int ox, oy;
};


#endif /* __DRAWABLE_H__ */
