/*
* main.cc:
*
* Copyright (c) 2001 James McKenzie <james@fishsoup.dhs.org>,
* All rights reserved.
*
*/

static char rcsid[] =
  "$Id: main.cc,v 1.18 2002/08/17 15:27:53 root Exp $";

/*
 * $Log: main.cc,v $
 * Revision 1.18  2002/08/17 15:27:53  root
 * #
 *
 * Revision 1.17  2002/08/17 11:30:19  root
 * #
 *
 * Revision 1.16  2002/08/15 15:30:59  root
 * #
 *
 * Revision 1.15  2002/08/15 11:41:06  root
 * #
 *
 * Revision 1.14  2002/06/21 17:33:06  root
 * #
 *
 * Revision 1.13  2001/12/16 17:56:08  root
 * #
 *
 * Revision 1.12  2001/12/16 17:44:02  root
 * #
 *
 * Revision 1.11  2001/12/16 17:33:58  root
 * #
 *
 * Revision 1.10  2001/12/16 17:32:38  root
 * #
 *
 * Revision 1.9  2001/12/06 21:04:21  root
 * #
 *
 * Revision 1.8  2001/12/06 17:47:19  root
 * #
 *
 * Revision 1.7  2001/12/06 17:47:08  root
 * #
 *
 * Revision 1.6  2001/12/06 16:18:04  root
 * #
 *
 * Revision 1.5  2001/12/06 04:26:39  root
 * #
 *
 * Revision 1.4  2001/12/06 01:02:21  root
 * #
 *
 * Revision 1.3  2001/12/05 20:13:37  root
 * #
 *
 */

#include "project.h"


Frame frame;
Panel panel;
Display *dpy;


Map *maps[] = { create_cursormap(), create_scalemap(), create_markupmap(), create_iosmap (), create_bosmap (100000), create_bosmap (20000), create_bosmap (10000), create_bosmap (1000), create_bammap (0.25), create_bammap(1.25), create_bammap(6.25), create_bammap(25.0), create_bsmmap(1.25), create_cambridge_az_map() };

int nmaps = sizeof (maps) / sizeof (Map *);
CoordSystem *cs[] = { new BosCoordSystem, new BosxyCoordSystem, new IosCoordSystem, new LatLonCoordSystem, new DMLatLonCoordSystem, new DMSLatLonCoordSystem, new GBPostCode, new GBPlace };
int ncs = sizeof (cs) / sizeof (CoordSystem *);
Place *places[] = { new Place (54.600564, -5.918675, string ("Belfast")), new Place (52.204916, 0.117853, string ("Cambridge")), new Place (53.346186, -6.258762, string ("Dublin")), new Place (55.943644, -3.161661, string ("Edinburgh")), new Place (52.240241, 0.083334, string ("Girton")), new Place (55.011933, -8.010862, string ("Glenveagh")), new Place (51.500309, -0.124286, string ("London")), new Place (57.439618, -6.685032, string ("Skye")) };
int nps = sizeof (places) / sizeof (Place *);


static void new_views (void)
{
  (void) new Views (LatLon (52.0, 0.0), maps, nmaps, cs, ncs, places, nps);
}

static void quit (void)
{
  exit (0);
}

int main (int argc, char *argv[])
{

#if 0
  pos = imgcoordsys->lltoic (cs->cstoll ("TL356820"));
#endif

  if (argc > 1) {
    argc--;
    argv++;
    while (argc--) {
      cmd_parse(*(argv++));
    }
    exit(0);
  }

  frame = xv_create (0, FRAME, FRAME_LABEL, rcsid, XV_SHOW, FALSE, 0);
  dpy = (Display *) xv_get (frame, XV_DISPLAY);
  int depth = xv_get (frame, WIN_DEPTH);
  gdk_pixbuf_xlib_init_with_depth (dpy, DefaultScreen (dpy), depth);

  panel = xv_create (frame, PANEL, 0);
  xv_create (panel, PANEL_BUTTON, PANEL_LABEL_STRING, "New Group",
             PANEL_NOTIFY_PROC, new_views, 0);

  xv_create (panel, PANEL_BUTTON, PANEL_LABEL_STRING, "Quit",
             PANEL_NOTIFY_PROC, quit, 0);

  window_fit (panel);
  window_fit (frame);

  xv_main_loop (frame);
}
