/*
 * markup_p.lex:
 *
 * Copyright (c) 2000 James McKenzie <james@fishsoup.dhs.org>,
 * All rights reserved.
 *
 */
%{
static char rcsid[]="$Id: markup_p.lex,v 1.1 2002/08/17 11:30:19 root Exp $";

/*
 *
 * $Log: markup_p.lex,v $
 * Revision 1.1  2002/08/17 11:30:19  root
 * #
 *
 * Revision 1.1  2002/08/15 15:30:59  root
 * #
 *
 * Revision 1.4  2000/10/07 18:30:03  root
 * #
 *
 * Revision 1.3  2000/09/24 01:12:43  root
 * #
 *
 * Revision 1.2  2000/09/19 03:53:27  root
 * #
 *
 * Revision 1.1  2000/09/13 15:13:40  root
 * #
 *
 *
 */


extern int markup_p_read(char *,int );
#define YY_INPUT(buf,result,size) result=markup_p_read((char *) buf,size);

#include "../project.h"
#include "markup_p.tab.h"

// line number
int markup_p_line = 1;


%}

%x		COMMENT

endofline	\n
quotes		[\"']
space		[ \t,]+
number		[0123456789]*\.[01234567890]*
inumber		[0123456789]+
color		#[0123456789abcdefABCDEF]{6}

%%

gis_markup		;
{space}			;
{endofline}		{ markup_p_line++; }

\/\/.*			;
"/*"			BEGIN COMMENT;
<COMMENT>.	|
<COMMENT>\n		;
<COMMENT>"*/"		BEGIN INITIAL;


icon			{ return MU_ICON; }
text			{ return MU_TEXT; }
line			{ return MU_LINE; }
eline			{ return MU_ELINE; }

[{]			{ return BRACE_IN; }

[}]			{ return BRACE_OUT; }

{quotes}[^\"]*{quotes} { 
	strcpy(markup_p_lval.string , markup_p_text + 1); 
	markup_p_lval.string[strlen(markup_p_lval.string) - 1] = 0; 
	return STRING;
}

{color} {
	strcpy(markup_p_lval.string , markup_p_text ); 
	return COLOR;
}
	

{number} {
	markup_p_lval.number=atof(markup_p_text);
	return NUMBER;
}

{inumber} {
	markup_p_lval.number=atof(markup_p_text);
	return NUMBER;
}


.			{ return markup_p_text[0]; }

%%


int markup_p_wrap()
{
	return 1;
}

