/*
 * markup_p.y:
 *
 * Copyright (c) 2002 James McKenzie <james@fishsoup.dhs.org>,
 * All rights reserved.
 *
 */

%{
static char rcsid[] = "$Id: markup_p.y,v 1.2 2002/08/17 15:50:56 root Exp root $";

/*
 * $Log: markup_p.y,v $
 * Revision 1.2  2002/08/17 15:50:56  root
 * #
 *
 * Revision 1.1  2002/08/17 11:30:19  root
 * #
 *
 * Revision 1.1  2002/08/15 15:30:59  root
 * #
 *
 * Revision 1.8  2001/10/12 13:51:11  root
 * #
 *
 * Revision 1.7  2001/10/04 18:21:16  root
 * #
 *
 * Revision 1.6  2001/10/04 18:00:36  root
 * #
 *
 * Revision 1.5  2000/10/07 18:30:03  root
 * #
 *
 * Revision 1.4  2000/09/24 01:12:43  root
 * #
 *
 * Revision 1.3  2000/09/19 05:06:22  root
 * #
 *
 * Revision 1.2  2000/09/19 03:53:27  root
 * #
 *
 * Revision 1.1  2000/09/13 15:13:40  root
 * #
 *
 */


#include "../project.h"
extern "C" {
#include <ctype.h>
};



typedef enum {START, BRACE_IN,BRACE_OUT,MU_ICON,MU_TEXT,MU_LINE,MU_ELINE} THING ;

extern int markup_p_read(char *buf,int len);



%}

%token BRACE_IN BRACE_OUT COLOR STRING NUMBER MU_ICON MU_TEXT MU_LINE MU_ELINE

%union {
		char string[1024];
		double number;
	}

%start decl_list

%%


decl_list:	decl 
	|	decl_list decl 
	;

decl:		MU_ICON NUMBER NUMBER STRING ';'		{ markup_p_icon($2.number,$3.number,$4.string); }
	|	MU_TEXT NUMBER NUMBER STRING ';'		{ markup_p_ntext($2.number,$3.number,$4.string,"#000000",0); }
	|	MU_TEXT NUMBER NUMBER STRING COLOR ';'		{ markup_p_ntext($2.number,$3.number,$4.string, $5.string,0 ); }
	|	MU_TEXT NUMBER NUMBER STRING STRING ';'		{ markup_p_ntext($2.number,$3.number,$4.string, $5.string,0); }
	|	MU_TEXT NUMBER NUMBER STRING NUMBER ';'		{ markup_p_ntext($2.number,$3.number,$4.string,"#000000", $5.number ); }
	|	MU_TEXT NUMBER NUMBER STRING COLOR NUMBER ';'		{ markup_p_ntext($2.number,$3.number,$4.string, $5.string,$6.number ); }
	|	MU_TEXT NUMBER NUMBER STRING STRING NUMBER ';'		{ markup_p_ntext($2.number,$3.number,$4.string, $5.string,$6.number ); }
	|	MU_LINE NUMBER NUMBER NUMBER NUMBER ';'			{ markup_p_nline($2.number,$3.number,$4.number,$5.number,"#000000",0.0); }
	|	MU_LINE NUMBER NUMBER NUMBER NUMBER COLOR ';'		{ markup_p_nline($2.number,$3.number,$4.number,$5.number,$6.string,0.0); }
	|	MU_LINE NUMBER NUMBER NUMBER NUMBER STRING ';'		{ markup_p_nline($2.number,$3.number,$4.number,$5.number,$6.string,0.0); }
	|	MU_LINE NUMBER NUMBER NUMBER NUMBER COLOR NUMBER ';'	{ markup_p_nline($2.number,$3.number,$4.number,$5.number,$6.string,$7.number); }
	|	MU_LINE NUMBER NUMBER NUMBER NUMBER STRING NUMBER ';'	{ markup_p_nline($2.number,$3.number,$4.number,$5.number,$6.string,$7.number); }
	|	MU_ELINE NUMBER NUMBER NUMBER NUMBER ';'		{ markup_p_eline($2.number,$3.number,$4.number,$5.number,"#000000",0.0); }
	|	MU_ELINE NUMBER NUMBER NUMBER NUMBER COLOR ';'		{ markup_p_eline($2.number,$3.number,$4.number,$5.number,$6.string,0.0); }
	|	MU_ELINE NUMBER NUMBER NUMBER NUMBER STRING ';'		{ markup_p_eline($2.number,$3.number,$4.number,$5.number,$6.string,0.0); }
	|	MU_ELINE NUMBER NUMBER NUMBER NUMBER COLOR NUMBER ';'	{ markup_p_eline($2.number,$3.number,$4.number,$5.number,$6.string,$7.number); }
	|	MU_ELINE NUMBER NUMBER NUMBER NUMBER STRING NUMBER ';'	{ markup_p_eline($2.number,$3.number,$4.number,$5.number,$6.string,$7.number); }
	|	';'
        ;

%%

extern int markup_p_line;
extern char *markup_p_text;
extern char *markup_p_name;


extern int markup_p_lex(void);


void markup_p_error(char *s)
{
	fprintf(stderr, "markup_p: %s line %d: %s near `%s'\n", markup_p_name,markup_p_line, s, markup_p_text);
}
