#include "project.h"

#include "coords/libcoords.h"

//for htonl stuff...
extern "C"
{
#  include <netinet/in.h>
};


static LatLon wgs84toll (WGS84 w)
{
  return LatLon (w.lat, w.lon);
}

string GBPostCode::name (void)
{
  return string ("UK PostCode");
}

string name (void);
string lltocs (LatLon);
LatLon cstoll (string);

string GBPostCode::lltocs (LatLon l)
{
  return string ("");
}

LatLon GBPostCode::cstoll (string s)
{
  LatLon ll (0, 0);
  BOSXY xy (0, 0);
  off_t o, lo;
  char r[30], lr[30];
  char buf[1024];
  char postcode[80];
  FILE *f;
  u_int32_t i;

  for (i = 0; i < s.length (); ++i) {
    postcode[i] = toupper (s[i]);
  }
  postcode[i] = 0;


  sprintf (buf, "%s/PAF_packed_index", getenv ("PAFPATH"));
  f = fopen (buf, "r");
  if (!f)
    return ll;

  bzero (r, 4);
  bzero (lr, 4);
  lo = 0;

  while (fgets (buf, sizeof (buf) - 1, f)) {
    bcopy (buf, r, 3);
    o = atoi (buf + 4);

    if ((strncmp (postcode, lr, 3) >= 0) && (strncmp (postcode, r, 3) < 0))
      break;

    bcopy (r, lr, 3);
    lo = o;
  }


  fclose (f);


  lo *= 16;


  sprintf (buf, "%s/PAF_packed", getenv ("PAFPATH"));
  f = fopen (buf, "r");
  if (!f)
    return ll;
  fseek (f, lo, SEEK_SET);
  bzero (lr, 16);
  bzero (r, 16);
  while (fread (r, 16, 1, f) == 1) {
    if ((strcmp (postcode, lr) >= 0) && (strcmp (postcode, r) < 0))
      break;
    bcopy (r, lr, 16);
  }

  fclose (f);

  bcopy (r + 8, &i, 4);
  xy.x = ntohl (i) * 10;
  bcopy (r + 12, &i, 4);
  xy.y = ntohl (i) * 10;

  if (strcmp (postcode, lr)) {
    printf ("Nearest match %s at (%d,%d)\n", lr, xy.x, xy.y);
  } else {
    printf ("Exact match %s at (%d,%d)\n", lr, xy.x, xy.y);
  }


  ll = wgs84toll (bosxy_to_wgs84 (xy));

  return ll;
}
