/*
* project.h:
*
* Copyright (c) 2001 James McKenzie <james@fishsoup.dhs.org>,
* All rights reserved.
*
*/

/*
 * $Id: project.h,v 1.18 2002/08/17 11:30:19 root Exp $
 */

/*
 * $Log: project.h,v $
 * Revision 1.18  2002/08/17 11:30:19  root
 * #
 *
 * Revision 1.17  2002/08/15 15:30:59  root
 * #
 *
 * Revision 1.16  2002/08/15 11:41:06  root
 * #
 *
 * Revision 1.15  2002/08/12 15:42:48  root
 * #
 *
 * Revision 1.14  2002/06/21 17:33:06  root
 * #
 *
 * Revision 1.13  2001/12/16 17:56:08  root
 * #
 *
 * Revision 1.12  2001/12/16 17:44:02  root
 * #
 *
 * Revision 1.11  2001/12/16 17:39:17  root
 * #
 *
 * Revision 1.10  2001/12/16 17:33:58  root
 * #
 *
 * Revision 1.9  2001/12/16 17:32:38  root
 * #
 *
 */

#ifndef __PROJECT_H__
#define __PROJECT_H__


extern "C"
{
#  include <math.h>
#  include <stdio.h>
#  include <xview/xview.h>
#  include <xview/frame.h>
#  include <xview/panel.h>
#  include <xview/canvas.h>
#  include <string.h>
#  include <strings.h>
#  include <gdk-pixbuf/gdk-pixbuf.h>
#  include <gdk-pixbuf/gdk-pixbuf-xlib.h>
#  include <gdk-pixbuf/gdk-pixbuf-xlibrgb.h>
#  include <libart_lgpl/libart.h>
};

#include <iostream>
#include <string>

using namespace std;

#include "fops.h"
#include "cache.h"
#include "coordinates.h"
#include "paf.h"
#include "places.h"
#include "color.h"
#include "drawable.h"
#include "map.h"
#include "cursor.h"
#include "markup.h"
#include "bos.h"
#include "bam.h"
#include "bsm.h"
#include "cambridge_az.h"
#include "ios.h"
#include "util.h"
#include "cmdview.h"
#include "view.h"
#include "views.h"
#include "cmd_p.h"

#define VIEWS_KEY 0x1000
#define CS_KEY 0x1001
#define MAP_KEY 0x1002
#define PLACE_KEY 0x1003

#define VIEW_KEY 0x2000
#define SCALE_KEY 0x2001


#define TILESIZE 200            //Size of tiles requested by front end

#define MAXTILES 2000           //Number of tiles to cache per map
#define MAXTILEPOINTS 5000000   //Maximum number of points in a tile
#define MAXTILESBYTES 16000000  //Maximum size of per map cache

#define MAXSUBTILES 100         //Maximum number of tiles to assemble to 
//make a front end tile
#endif __PROJECT_H__
