/*
* util.cc:
*
* Copyright (c) 2001 James McKenzie <james@fishsoup.dhs.org>,
* All rights reserved.
*
*/

static char rcsid[] = "$Id: util.cc,v 1.9 2001/12/16 17:56:08 root Exp $";

/*
 * $Log: util.cc,v $
 * Revision 1.9  2001/12/16 17:56:08  root
 * #
 *
 * Revision 1.8  2001/12/16 17:44:02  root
 * #
 *
 * Revision 1.7  2001/12/16 17:33:58  root
 * #
 *
 * Revision 1.6  2001/12/16 17:32:38  root
 * #
 *
 * Revision 1.5  2001/12/06 17:47:19  root
 * #
 *
 * Revision 1.4  2001/12/06 17:47:08  root
 * #
 *
 * Revision 1.3  2001/12/06 04:26:39  root
 * #
 *
 * Revision 1.2  2001/12/06 01:02:21  root
 * #
 *
 * Revision 1.1  2001/12/05 20:13:37  root
 * #
 *
 *
 */

#include "project.h"


static void do_msg (char *pre, char *where, int line, char *post, const char *fmt, va_list ap)
{
  char cbuf[10240], *ptr = cbuf;

  if (pre)
    ptr += sprintf (ptr, "%s:", pre);
  ptr += sprintf (ptr, "%d:%s%05d:", getpid (), where, line);
  if (post)
    ptr += sprintf (ptr, "%s:", post);
  if (fmt)
    ptr += vsprintf (ptr, fmt, ap);
  *(ptr++) = '\n';
  *ptr = 0;

  fputs (cbuf, stderr);
  fflush (stderr);
}

static void msg (char *where, int line, const char *fmt, ...)
{
  va_list ap;

  va_start (ap, fmt);
  do_msg (NULL, where, line, NULL, fmt, ap);
  va_end (ap);
}


void errormsg (char *where, int line, const char *fmt, ...)
{
  va_list ap;
  va_start (ap, fmt);
  do_msg ("ERROR", where, line, NULL, fmt, ap);
  va_end (ap);

}


void crash_and_burn (void)
{
  char buf[1024];
  getcwd (buf, sizeof (buf));
  ERRORMSG ("crashing and burning in %s", buf);
  abort ();
}

double round_down (double v, double b)
{
  return floor (v / b) * b;
}

double round_up (double v, double b)
{
  return ceil (v / b) * b;
}
