/*
* util.h:
*
* Copyright (c) 2001 James McKenzie <james@fishsoup.dhs.org>,
* All rights reserved.
*
*/

/*
 * $Id: util.h,v 1.5 2001/12/16 17:33:58 root Exp $
 */

/*
 * $Log: util.h,v $
 * Revision 1.5  2001/12/16 17:33:58  root
 * #
 *
 * Revision 1.4  2001/12/06 17:47:08  root
 * #
 *
 * Revision 1.3  2001/12/06 04:26:39  root
 * #
 *
 * Revision 1.2  2001/12/06 01:02:21  root
 * #
 *
 * Revision 1.1  2001/12/05 20:13:37  root
 * #
 *
 *
 */

#ifndef __UTIL_H__
#define __UTIL_H__


#ifdef DEBUG
#define DEBUGMSG(a...)	msg(__FILE__ ":" "c++" ":",__LINE__,a)
#else
#define DEBUGMSG(a...) {}
#endif

#define ERRORMSG(a...)  errormsg(__FILE__ ":" "c++" ":",__LINE__,a)
#define FATALERROR(a...) do { ERRORMSG(a); crash_and_burn(); } while (0)
#define FATALMSG(a...) FATALERROR(a)

#define CHECKPOINT	DEBUGMSG(NULL)
#define CRASHANDBURN	FATALMSG(NULL)


extern void errormsg (char *where, int line, const char *fmt, ...);
extern void crash_and_burn (void);

extern double round_up (double, double);
extern double round_down (double, double);

#endif /* __UTIL_H__ */
