/*
* view.h:
*
* Copyright (c) 2001 James McKenzie <james@fishsoup.dhs.org>,
* All rights reserved.
*
*/

/*
 * $Id: view.h,v 1.9 2002/08/15 11:41:06 root Exp $
 */

/*
 * $Log: view.h,v $
 * Revision 1.9  2002/08/15 11:41:06  root
 * #
 *
 * Revision 1.8  2002/08/12 15:42:48  root
 * #
 *
 * Revision 1.7  2002/06/21 17:33:06  root
 * #
 *
 * Revision 1.6  2001/12/16 17:44:02  root
 * #
 *
 * Revision 1.5  2001/12/16 17:33:58  root
 * #
 *
 * Revision 1.4  2001/12/06 21:04:21  root
 * #
 *
 * Revision 1.3  2001/12/06 17:47:08  root
 * #
 *
 * Revision 1.2  2001/12/06 16:18:04  root
 * #
 *
 * Revision 1.1  2001/12/06 04:26:39  root
 * #
 *
 */

#ifndef __VIEW_H__
#define __VIEW_H__

class Views;

class View
{
public:

  //X connection
  Display * dpy;
  Window win;
  GC gc;
  int depth;

  // UI elements
  Views *parent;
  View *prev;
  View *next;

  Frame frame;
  Panel panel;
  Canvas canvas;

  Frame mapframe;
  Panel mappanel;
  Panel_item *mapmaps;

  Frame printframe;
  Panel printpanel;
  Panel_item printwhere;
  Panel_item printres, printxpx, printypx, printylen, printxlen;
  Panel_item printchange, printstatus;

  //Remembered canvas size (used to detect resize events)
  int cw, ch;

  //Scale (position is in the parent below)
  double scale;

  //Maps are in the parent below
  int *usemaps;                 //list of maps to use [owned by us]
  int nmaps;


  //ImageCoordinateSystem [not owned by us]
  ImageCoordSystem *imgcoordsys;

  View (Views *, ImageCoordSystem *, double scale, int *);
  ~View ();

  void repaint (void);
  //FIXME: hanlde motion spearately from a repaint

  void print(FILE *, int, int);

}
;

//Controls the size of tiles requested from layers beneeth
//for mixing together.



#endif /* __VIEW_H__ */
