/*
* views.h:
*
* Copyright (c) 2001 James McKenzie <james@fishsoup.dhs.org>,
* All rights reserved.
*
*/

/*
 * $Id: views.h,v 1.6 2001/12/16 17:44:02 root Exp $
 */

/*
 * $Log: views.h,v $
 * Revision 1.6  2001/12/16 17:44:02  root
 * #
 *
 * Revision 1.5  2001/12/16 17:33:58  root
 * #
 *
 * Revision 1.4  2001/12/16 17:32:38  root
 * #
 *
 * Revision 1.3  2001/12/06 21:04:21  root
 * #
 *
 * Revision 1.2  2001/12/06 17:47:19  root
 * #
 *
 * Revision 1.1  2001/12/06 17:47:08  root
 * #
 *
 */

#ifndef __VIEWS_H__
#define __VIEWS_H__


class Views
{
public:
  //list of View classes above
  View * head;
  View *tail;

  //UI Elements
  Frame frame;
  Panel panel;
  Panel_item *csi;

  //center position
  LatLon pos;

  //list of maps (not owned by us)
  Map **maps;
  int nmaps;

  //list of coordinate systems (not owned by us)
  CoordSystem **cs;
  int ncs;

  Views (LatLon ipos, Map **, int, CoordSystem **, int, Place **, int);
  ~Views ();

  void repaint_all (void);
  void newpos (void);
  void new_view (int);
};


#endif /* __VIEWS_H__ */
